SystemOrganization addCategory: #'GT-InspectorExtensions-CoreRoassal'!

Object subclass: #GTExamplePainter
	instanceVariableNames: 'example elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-InspectorExtensions-CoreRoassal'!

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 14:42'!
borderColorForExample: anExample
	^ [ self colorForResult: anExample result ]
		on: Error
		do: [ self colorForExample: anExample ]! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 17:09'!
buildEdges: aBlock inView: aView
	| edges container fromElement toElements elementsWithModels |
	elements isEmpty ifTrue: [ ^ #() ].
	edges := OrderedCollection new.
	elementsWithModels := elements select: [ :el | el model notNil ].
	
	elementsWithModels do: [ :element |
		container := element view.
		fromElement := container elementFromModel: (#yourself rtValue: element model).
		
		"We get the list of elements that corresponds to (toBlock roValues: element model)"
		toElements := OrderedCollection new.
		([ :node | self dependenciesOrArgumentsForExample: node ] rtValue: element model) do: [ :model | 
			| v |
			v := container elementFromModel: model.
			v notNil ifTrue: [ toElements add: v ] ].
		
		
		(fromElement notNil and: [ toElements notEmpty ])
			ifTrue: [  
				toElements do: [ :toElement |
					| edge line |
					edge := RTEdge from: fromElement to: toElement. 
					line := RTArrowedLine new 
						color: Color black; 
						attachPoint: RTVerticalAttachPoint instance;
						yourself.
					aBlock value: edge value: fromElement value: toElement value: line.
					edge + line.
					edges add: edge.
					container add: edge ] ]  ].
	aView addAll: edges.! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 17:29'!
buildElements: aRootExample inView: aView
	| traverser |
	" init "
	elements := RTGroup new.
	
	" root element "
	elements add: (self elementForExample: aRootExample with: [ :shape | shape size: 48 ]).
	
	" top-down "
	(traverser := aRootExample traverser)
		onRecursionError: [ :aProcessor :anExample | self onRecursionError: anExample ];
		onArgumentError: [ :aProcessor :anExample :someArguments | self onArgumentError: anExample ];
		onDependencyError: [ :aProcessor :anExample :anException | self onDependencyError: anExample ];
		action: [ :anExample | self onAction: anExample ];
		value.
	
	" bottom up "
	traverser reversed value.
	
	" add to view "
	aView addAll: elements @ (RTPopup text: [ :node | node gtDisplayString ]) @ RTDraggable.! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 15:18'!
buildLayoutinView: aView
	" layout -> graph instead of tree "
	RTTreeLayout new on: elements! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 14:58'!
colorForExample: anExample
	^ anExample exists 
		ifTrue: [ anExample isValid 
			ifTrue: [ self defaultColorForExample: anExample ] 
			ifFalse: [ Color red ] ] 
		ifFalse: [ (Color r: 1 g: 0 b: 0 alpha: 0.05) ]! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 14:58'!
colorForResult: aResult
	aResult isSuccess ifTrue: [ ^ Color green ].
	aResult isFailure ifTrue: [ ^ Color yellow ].
	aResult isError ifTrue: [ ^ Color red ].
	^ self defaultColorForExample: nil! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 14:57'!
defaultColorForExample: anExample
	^ Color black! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 8/31/2015 22:52'!
dependenciesOrArgumentsForExample: anExample
	^ [ anExample arguments collect: [ :each | 
		[ each example ] 
			on: Error 
			do: [ :exception | each ] ] ] on: Error do: [ #() ]! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 8/31/2015 22:28'!
elementByExample: anExample
	^ elements 
		detect: [ :element | element model == anExample ] 
		ifNone: [ nil ]! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 17:04'!
elementByExample: anExample do: aBlock1 ifNone: aBlock2
	(self elementByExample: anExample)
		ifNotNil: aBlock1
		ifNil: aBlock2! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 8/31/2015 22:38'!
elementForExample: anExample
	^ self elementForExample: anExample with: [ :shape | ]! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 14:57'!
elementForExample: anExample with: aBlock
	| shape |
	shape := RTBox new 
		size: 24;
		color: (self defaultColorForExample: anExample);
		borderColor: (self borderColorForExample: anExample);
		borderWidth: 2;
		yourself.
	aBlock value: shape.
	^ shape elementOn: anExample! !

!GTExamplePainter methodsFor: 'accessing' stamp: 'StefanReichhart 8/31/2015 22:26'!
example
	^ example! !

!GTExamplePainter methodsFor: 'accessing' stamp: 'StefanReichhart 8/31/2015 22:26'!
example: anObject
	example := anObject! !

!GTExamplePainter methodsFor: 'public' stamp: 'StefanReichhart 8/31/2015 22:56'!
gtInspectorRoassalIn: composite
	self hasRoassal2 ifFalse: [ ^ self ].
	^ composite roassal2
		title: 'Graph';
		painting: [ :view :node | self viewGraph: node on: view ];
		yourself! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 8/31/2015 22:57'!
hasRoassal2
	^ (Smalltalk classNamed: #GLMRoassal2Presentation) notNil! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/2/2015 21:20'!
onAction: anExample
	self elementByExample: anExample
		do: [ :element | ]
		ifNone: [ elements add: (self elementForExample: anExample) ] ! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 14:43'!
onArgumentError: anExample
	self elementByExample: anExample
		do: [ :element | 
			element color: Color red.
			(self dependenciesOrArgumentsForExample: anExample) do: [ :argument |
				self elementByExample: argument
					do: [ :subElement | ]
					ifNone: [ elements add: (self elementForExample: argument with: [ :shape | shape 
							color: (self colorForExample: argument); 
							borderColor: (self borderColorForExample: argument) ]) ] ] ]
		ifNone: [ ] ! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 14:38'!
onDependencyError: anExample
	self elementByExample: anExample
		do: [ :element | 
			anExample hasValidArguments 
				ifFalse: [ element color: Color red ] ]
		ifNone: [ 
			elements add: (self elementForExample: anExample) ].
		
	anExample arguments do: [ :argument |
		elements add: (self elementForExample: argument with: [ :shape | shape 
			color: (self colorForExample: argument); 
			borderColor: (self borderColorForExample: argument) ]) ] ! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/2/2015 21:19'!
onRecursionError: anExample
	self elementByExample: anExample
		do: [ :element | element color: Color yellow ]
		ifNone: [  ] ! !

!GTExamplePainter methodsFor: 'private-painting' stamp: 'StefanReichhart 9/4/2015 15:23'!
viewGraph: aRootExample on: aView
	self buildElements: aRootExample inView: aView.
	self buildEdges: [ :edge :from :to :line | 
		from model hasValidArguments ifFalse: [ line color: Color red ] ] inView: aView.
	self buildLayoutinView: aView.
	
	^ aView! !

!GLMCompositePresentation methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 10/24/2014 06:52'!
gtInspectorOpenTreeIn: composite
	<gtInspectorPresentationOrder: 30>  
	^ composite roassal2
		title: 'Tree';
		painting: [:view :b | 
			self viewTreeOn: view ]! !

!GLMCompositePresentation methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 10/24/2014 06:53'!
viewTreeOn: view
	| b label line elements |

	b := RTUMLClassBuilder new.
	b
		addObjects: self pane withAllPanes;
		classname: #name;
		instanceVariables: nil;
		methodsNames: #ports;
		methodselector: #name;
		attributeselector: nil;
		buildSchema: view.
	elements := RTGroup new.
	elements addAll: b classesGroup.
	
	label := RTLabel new height: 10; text: [:p | (p class name removePrefix: 'GLM') removeSuffix: 'Presentation' ].
	
	self pane withAllPresentations do: [ :p | | e |
		view add: (e:= (label elementOn: p ) @ RTDraggable).
		elements add: e ].
	
	line := RTMultiLine new orthoVertical attachPoint: RTVerticalAttachPoint instance.
	
	RTEdge buildEdgesFromObjects: self pane withAllPanes 
		from: #yourself to: [ :each | each presentations ] using: line inView: view.
	
	RTEdge buildEdgesFromObjects: self pane withAllPanes 
		from: #browser to: #yourself using: line inView: view.
		
	RTEdge buildEdgesFromObjects: (self pane withAllPresentations select: [:each | each isKindOf: GLMDynamicPresentation])
		from: #yourself to: #cachedPresentation using: line inView: view scope: elements.
		
	RTEdge buildEdgesFromObjects: (self pane withAllPresentations select: [:each | each isKindOf: GLMCompositePresentation])
		from: #yourself toAll: #presentations using: line inView: view scope: elements.
		
	RTTreeLayout new on: elements.
	
	line := RTLine new color: Color blue; attachPoint: RTShorterDistanceAttachPoint instance.
	RTEdge buildEdgesFromObjects: ((self pane withAllPresentations select: [:each | each isKindOf: GLMBrowser]) flatCollect: [:each | each transmissions])
		from: #destination toAll: #origins using: line inView: view.
	! !

GLMCompositePresentation subclass: #GTInspectorMessageTallyCharter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-InspectorExtensions-CoreRoassal'!

!GTInspectorMessageTallyCharter commentStamp: 'TudorGirba 1/18/2014 14:28' prior: 0!
Helper class for displaying charts specific for a MessageTally.!

!GTInspectorMessageTallyCharter methodsFor: 'visualization' stamp: 'TudorGirba 10/26/2014 21:01'!
performanceOf: aMessageTally with: builder in: presentation
	"Displays a double chart showing the top 20 most costly methods within a MessageTally.
	For each method it sows the number of occurences of a method and the 
	total amount of local tallies for that method. Useful for identifying outliers 
	within one execution."
	
	| all grouped metric |
	metric := #localTally.
	all := aMessageTally deepCollect: [ :each | each sonsOver: 1 ].
	grouped := (all groupedBy: [ :each | String streamContents: [:s | each gtDisplayIdentifierOn: s] ]) 
						associations sorted: [:a :b | 
									(a value sumNumbers: metric) > 
									(b value sumNumbers: metric) ].
	grouped := (grouped first: (20 min: grouped size)) select: [:each | (each value sumNumbers: metric) > 0].
	builder pointName: [ :each | each key ].
	builder points: grouped.
	builder bottomValue: [ :each | each key size ] titled: 'Locations'.
	builder topValue: [ :each | each value sumNumbers: metric ] titled: 'Tallies'! !

!RTAbstractExample class methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'AndreiChis 10/4/2015 21:01'!
gtInspectorGTExamplesIn: composite
	
	^ self new gtInspectorPreviewIn: composite! !

!GTInspector class methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 9/4/2015 23:14'!
gtInspectorExtensionsMapIn: composite
	<gtInspectorPresentationOrder: 50>
	composite roassal2
		title: 'GT extensions map';
		initializeView: [ RTCircularTreeMapBuilder new ];
		painting: [ :b |
			b
				color: [ : each | 
					each isClassOrTrait 
						ifTrue: [ 
							((Pragma allNamed: #gtInspectorPresentationOrder: in: each) isEmpty 
								and: [ (Pragma allNamed: #spotterOrder: in: each) isEmpty ]) 
								ifTrue: [ Color lightGray alpha: 0.5 ]
								ifFalse: [ Color red ] ] 
						ifFalse: [ Color transparent ]];
				borderColor: Color gray; 
				baseradius: 500;
				leafWeight: [ :each | each methods size ].
			b 
				from: RPackageOrganizer default packages
				nesting: [ :each | 
					(each isKindOf: RPackage)
						ifTrue: [ each classTags ]
						ifFalse: [ {  } ] ]
				leaves: [ :each |
					(each isKindOf: RPackage)
						ifTrue: [ { } ]
						ifFalse: [ each classes ] ].
			b build view canvas camera focusOnCenterScaled.
			b ]! !

!RTView class methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'AlexandreBergel 9/28/2015 08:55'!
gtExamplesProvider

	^ RTRoassalExample new! !

!MessageTally methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 10/27/2014 00:26'!
gtInspectorMessageTreeIn: composite
	<gtInspectorPresentationOrder: 40>
	| methods normalizer |
	methods := self withDeepCollect: #children.
	normalizer := RTNColorLinearNormalizer 
						inContext: methods 
						withCommand: #tally 
						lowColor: Color gray 
						highColor: Color red.
	^ (composite tree)
		title: 'Tree';
		children: [ :each | each children ];
		"rootsExpanded;"
		format: [ :each | 
			Text 
				string: each gtDisplayString
				attributes: { TextColor color: (normalizer rtValue: each)}];
		when: [ self children notEmpty ];
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ];
		morphicSelectionAct: [ :list | list selection method browse ]
			icon: GLMUIThemeExtraIcons glamorousBrowse
			on: $b
			entitled: 'Browse (b)'
		! !

!MessageTally methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 10/4/2014 07:19'!
gtInspectorPerformanceChartIn: composite
	<gtInspectorPresentationOrder: 40>
	| metric |
	metric := #localTally.
	^ composite roassal2
		title: 'Top tallies';
		initializeView: [ RTDoubleBarBuilder new ];
		painting: [ :builder :presentation |
			GTInspectorMessageTallyCharter new 
				performanceOf: self 
				with: builder
				in: presentation ];
		when: [ self children notEmpty ]! !

!MessageTally methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 4/10/2016 00:26'!
gtInspectorSunburstIn: composite
	<gtInspectorPresentationOrder: 40>
	| methods normalizer |
	methods := self withDeepCollect: #children.
	normalizer := RTNColorLinearNormalizer 
						inContext: methods 
						withCommand: #tally 
						lowColor: Color veryLightGray 
						highColor: Color red.
	^ composite roassal2
		title: 'Sunburst';
		initializeView: [ RTSunburstBuilder new ];
		painting: [ :b :presentation |
			b strategy radialSpacing: 1.
			b shape current
				color: normalizer.
			b
				angularSpacing: 1;
				from: (Array with: self) using: #children ];
		when: [ self children notEmpty ]! !

!GLMBrowser methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 10/24/2014 06:52'!
gtInspectorOpenTreeIn: composite
	<gtInspectorPresentationOrder: 30>  
	^ composite roassal2
		title: 'Tree';
		painting: [:view :b | 
			self viewTreeOn: view ]! !

!GLMBrowser methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 10/27/2014 08:45'!
openTree
	| composer |
	composer := GLMCompositePresentation new.
	composer 
		act: [:b | b update] 
		icon: GLMUIThemeExtraIcons glamorousRefresh 
		entitled: 'Update'.
	composer tabulator with: [:t | 
		t column: #theOne.
		t transmit to: #theOne; andShow: [:a | 
			a roassal2 
				updateOn: GLMTransmissionTriggered from: [ self announcer ];
				painting: [:view :b | self viewTreeOn: view ] ]].
	composer openOn: self! !

!GLMBrowser methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'tg 5/18/2010 13:50'!
screenshot: aFilenameString on: anObject after: aBlock
	 
	| window |
	window := self openOn: anObject.
	aBlock glamourValue: self asGlamorousMultiValue.
	World doOneCycle.
	PNGReadWriter putForm: window imageForm onFileNamed: aFilenameString.
	^ window! !

!GLMBrowser methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 10/24/2014 22:42'!
viewAnnouncementsOn: view
	"view shape rectangle withoutBorder.
	view node: 'Glamour' forIt: [
		self viewTreeOn: view ].
	self umlClassWithTitle: #yourself view: view nodes: (Array with: 'Announced objects') forEach: [ :eachNode |
		view interaction
				nodraggable;
				forward: ROAbstractMouseDragging.
		view shape label text: [:p | (p class name removePrefix: 'GLM') removeSuffix: 'Renderer' ].
		view nodes: 
			(self pane withAllPanes flatCollect: [:each | 
			each glmSubscriptions collect: [:eachSub | eachSub subscriber]]) asSet.
		view interaction
				nodraggable;
				forward: ROAbstractMouseDragging.
		view shape label text: [:p | (p class name removePrefix: 'GLM') removeSuffix: 'Renderer' ].
		view nodes: 
			(self pane withAllPresentations flatCollect: [:each | 
			each glmSubscriptions collect: [:eachSub | eachSub subscriber]]) asIdentitySet.
		view verticalLineLayout ].
	
	view shape line 
			color: Color red twiceLighter;
			attachPoint: (ROHorizontalAttachPoint new).
	view edges: self pane withAllPanes from: #yourself toAll: [:each | 
			each glmSubscriptions collect: [:eachSub | eachSub subscriber]].
	view shape line 
			color: Color red twiceLighter;
			attachPoint: (ROHorizontalAttachPoint new).
	view edges: self pane withAllPresentations from: #yourself toAll: [:each | 
			each glmSubscriptions collect: [:eachSub | eachSub subscriber]].
	view horizontalLineLayout horizontalGap: 50"! !

!GLMBrowser methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'akevalion 10/23/2014 15:29'!
viewTree

	| view |
	view := RTView new.
	view @ RTDraggableView.
	self viewTreeOn: view.
	^ view open.! !

!GLMBrowser methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'akevalion 10/24/2014 18:04'!
viewTreeOn: view
	| b label line elements |

	b := RTUMLClassBuilder new.
	b
		addObjects: self pane withAllPanes;
		classname: #name;
		instanceVariables: nil;
		methodsNames: #ports;
		methodselector: #name;
		attributeselector: nil;
		buildSchema: view.
	elements := RTGroup new.
	elements addAll: b classesGroup.
	
	label := RTLabel new height: 10; text: [:p | (p class name removePrefix: 'GLM') removeSuffix: 'Presentation' ].
	
	self pane withAllPresentations do: [ :p | | e |
		view add: (e:= (label elementOn: p ) @ RTDraggable).
		elements add: e ].
	
	line := RTMultiLine new orthoVertical attachPoint: RTVerticalAttachPoint instance.
	
	RTEdge buildEdgesFromObjects: self pane withAllPanes 
		from: #yourself to: [ :each | each presentations ] using: line inView: view.
	
	RTEdge buildEdgesFromObjects: self pane withAllPanes 
		from: #browser to: #yourself using: line inView: view.
		
	RTEdge buildEdgesFromObjects: (self pane withAllPresentations select: [:each | each isKindOf: GLMDynamicPresentation])
		from: #yourself to: #cachedPresentation using: line inView: view scope: elements.
		
	RTEdge buildEdgesFromObjects: (self pane withAllPresentations select: [:each | each isKindOf: GLMCompositePresentation])
		from: #yourself toAll: #presentations using: line inView: view scope: elements.
		
	
	
	line := RTArrowedLine new color: Color blue; attachPoint: RTShorterDistanceAttachPoint instance.
	RTEdge buildEdgesFromObjects: ((self pane withAllPresentations select: [:each | each isKindOf: GLMBrowser]) flatCollect: [:each | each transmissions])
		from: #destination toAll: #origins using: line inView: view.
		
	RTTreeLayout new on: elements.
	! !

!FileReference methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 4/7/2016 21:39'!
gtInspectorGroupedFilesIn: composite
	<gtInspectorPresentationOrder: 40>
	^ composite roassal2
		title: 'Grouped files';
		initializeView: [ RTDoubleBarBuilder new ];
		painting: [ :builder :presentation |
			| metric all grouped |
			metric := #size.
			all := self allFiles.
			grouped := (all groupedBy: [ :each | each extension ]) 
								associations sorted: [:a :b | 
											(a value sumNumbers: metric) > 
											(b value sumNumbers: metric) ].
			grouped := (grouped first: (20 min: grouped size)) select: [:each | 
					(each value sumNumbers: metric) > 0].
			builder pointName: [ :each | each key ].
			builder points: grouped.
			builder bottomValue: [ :each | each value size ] titled: 'Number of files'.
			builder 
				topValue: [ :each | (each value sumNumbers: metric) / 1000000 ] 
				titled: 'Total size in MB'];
		send: #value;
		when: [self isDirectory and: [self hasChildren]]! !

!GLMSystemWindow methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 12/18/2013 05:26'!
gtInspectorOpenTreeIn: composite
	<gtInspectorPresentationOrder: 30>  
	^ (self model 
		gtInspectorOpenTreeIn: composite)
		title: 'Browser tree'! !

!MetacelloVersion methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 5/15/2015 10:32'!
gtInspectorProjectMapIn: composite
	<gtInspectorPresentationOrder: 40>
	composite roassal2
		title: 'Project map';
		initializeView: [ RTMondrian new ];
		painting: [ :view |
			view shape label text: [:each | each asString copyReplaceAll: 'ConfigurationOf' with: ''].
			view nodes: self allProjects.
			view edges
				 connectFrom: #yourself  toAll: [:each | each projects collect: #version].
			view layout horizontalDominanceTree layered ]! !

!GTExample methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'StefanReichhart 9/21/2015 20:35'!
gtInspectorRoassalIn: composite
	<gtInspectorPresentationOrder: 1>
	self hasRelationships ifFalse: [ ^ self ].
	^ self painter gtInspectorRoassalIn: composite! !

!GTExample methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'StefanReichhart 9/6/2015 17:45'!
painter
	^ GTExamplePainter new 
		example: self;
		yourself! !
